# .AnalysisApi

All URIs are relative to *https://lichess.org*

Method | HTTP request | Description
------------- | ------------- | -------------
[**apiCloudEval**](AnalysisApi.md#apiCloudEval) | **GET** /api/cloud-eval | Get cloud evaluation of a position.


# **apiCloudEval**
> void apiCloudEval()

Get the cached evaluation of a position, if available.  Opening positions have more chances of being available. There are about 7 million positions in the database.  Up to 5 variations may be available. Variants are supported. 

### Example


```typescript
import {  } from '';
import * as fs from 'fs';

const configuration = .createConfiguration();
const apiInstance = new .AnalysisApi(configuration);

let body:.AnalysisApiApiCloudEvalRequest = {
  // string | FEN of the position
  fen: "rnbqkbnr/ppp1pppp/8/3pP3/8/8/PPPP1PPP/RNBQKBNR b KQkq - 0 2",
  // number | Number of variations (optional)
  multiPv: 1,
  // VariantKey | Variant (optional)
  variant: "standard",
};

apiInstance.apiCloudEval(body).then((data:any) => {
  console.log('API called successfully. Returned data: ' + data);
}).catch((error:any) => console.error(error));
```


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fen** | [**string**] | FEN of the position | defaults to undefined
 **multiPv** | [**number**] | Number of variations | (optional) defaults to 1
 **variant** | **VariantKey** | Variant | (optional) defaults to undefined


### Return type

**void**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json


### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The evaluation of the position. |  * Access-Control-Allow-Origin -  <br>  |

[[Back to top]](#) [[Back to API list]](README.md#documentation-for-api-endpoints) [[Back to Model list]](README.md#documentation-for-models) [[Back to README]](README.md)


