# .TablebaseApi

All URIs are relative to *https://lichess.org*

Method | HTTP request | Description
------------- | ------------- | -------------
[**antichessAtomic**](TablebaseApi.md#antichessAtomic) | **GET** /antichess | Tablebase lookup for Antichess
[**tablebaseAtomic**](TablebaseApi.md#tablebaseAtomic) | **GET** /atomic | Tablebase lookup for Atomic chess
[**tablebaseStandard**](TablebaseApi.md#tablebaseStandard) | **GET** /standard | Tablebase lookup


# **antichessAtomic**
> string antichessAtomic()


### Example


```typescript
import {  } from '';
import * as fs from 'fs';

const configuration = .createConfiguration();
const apiInstance = new .TablebaseApi(configuration);

let body:any = {};

apiInstance.antichessAtomic(body).then((data:any) => {
  console.log('API called successfully. Returned data: ' + data);
}).catch((error:any) => console.error(error));
```


### Parameters
This endpoint does not need any parameter.


### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: text/plain


### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The tablebase information for the position in atomic chess. |  * Access-Control-Allow-Origin -  <br>  |

[[Back to top]](#) [[Back to API list]](README.md#documentation-for-api-endpoints) [[Back to Model list]](README.md#documentation-for-models) [[Back to README]](README.md)

# **tablebaseAtomic**
> string tablebaseAtomic()


### Example


```typescript
import {  } from '';
import * as fs from 'fs';

const configuration = .createConfiguration();
const apiInstance = new .TablebaseApi(configuration);

let body:any = {};

apiInstance.tablebaseAtomic(body).then((data:any) => {
  console.log('API called successfully. Returned data: ' + data);
}).catch((error:any) => console.error(error));
```


### Parameters
This endpoint does not need any parameter.


### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: text/plain


### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The tablebase information for the position in atomic chess. |  * Access-Control-Allow-Origin -  <br>  |

[[Back to top]](#) [[Back to API list]](README.md#documentation-for-api-endpoints) [[Back to Model list]](README.md#documentation-for-models) [[Back to README]](README.md)

# **tablebaseStandard**
> TablebaseJson tablebaseStandard()

**Endpoint: <https://tablebase.lichess.ovh>**  Example: `curl http://tablebase.lichess.ovh/standard?fen=4k3/6KP/8/8/8/8/7p/8_w_-_-_0_1` 

### Example


```typescript
import {  } from '';
import * as fs from 'fs';

const configuration = .createConfiguration();
const apiInstance = new .TablebaseApi(configuration);

let body:.TablebaseApiTablebaseStandardRequest = {
  // string | FEN of the position. Underscores allowed.
  fen: "fen_example",
};

apiInstance.tablebaseStandard(body).then((data:any) => {
  console.log('API called successfully. Returned data: ' + data);
}).catch((error:any) => console.error(error));
```


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fen** | [**string**] | FEN of the position. Underscores allowed. | defaults to undefined


### Return type

**TablebaseJson**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json


### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The tablebase information for the position in standard chess. |  * Access-Control-Allow-Origin -  <br>  |

[[Back to top]](#) [[Back to API list]](README.md#documentation-for-api-endpoints) [[Back to Model list]](README.md#documentation-for-models) [[Back to README]](README.md)


