/**
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { GameJsonAnalysis } from './GameJsonAnalysis';
import { GameJsonClock } from './GameJsonClock';
import { GameJsonOpening } from './GameJsonOpening';
import { GameJsonPlayers } from './GameJsonPlayers';
import { GameStatus } from './GameStatus';
import { Speed } from './Speed';
import { VariantKey } from './VariantKey';
import { HttpFile } from '../http/http';

export class GameJson {
    'id': string;
    'rated': boolean;
    'variant': VariantKey;
    'speed': Speed;
    'perf': string;
    'createdAt': number;
    'lastMoveAt': number;
    'status': GameStatus;
    'players': GameJsonPlayers;
    'initialFen'?: string;
    'winner'?: GameJsonWinnerEnum;
    'opening'?: GameJsonOpening;
    'moves'?: string;
    'pgn'?: string;
    'daysPerTurn'?: number;
    'analysis'?: Array<GameJsonAnalysis>;
    'tournament'?: string;
    'swiss'?: string;
    'clock'?: GameJsonClock;

    static readonly discriminator: string | undefined = undefined;

    static readonly attributeTypeMap: Array<{name: string, baseName: string, type: string, format: string}> = [
        {
            "name": "id",
            "baseName": "id",
            "type": "string",
            "format": ""
        },
        {
            "name": "rated",
            "baseName": "rated",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "variant",
            "baseName": "variant",
            "type": "VariantKey",
            "format": ""
        },
        {
            "name": "speed",
            "baseName": "speed",
            "type": "Speed",
            "format": ""
        },
        {
            "name": "perf",
            "baseName": "perf",
            "type": "string",
            "format": ""
        },
        {
            "name": "createdAt",
            "baseName": "createdAt",
            "type": "number",
            "format": ""
        },
        {
            "name": "lastMoveAt",
            "baseName": "lastMoveAt",
            "type": "number",
            "format": ""
        },
        {
            "name": "status",
            "baseName": "status",
            "type": "GameStatus",
            "format": ""
        },
        {
            "name": "players",
            "baseName": "players",
            "type": "GameJsonPlayers",
            "format": ""
        },
        {
            "name": "initialFen",
            "baseName": "initialFen",
            "type": "string",
            "format": ""
        },
        {
            "name": "winner",
            "baseName": "winner",
            "type": "GameJsonWinnerEnum",
            "format": ""
        },
        {
            "name": "opening",
            "baseName": "opening",
            "type": "GameJsonOpening",
            "format": ""
        },
        {
            "name": "moves",
            "baseName": "moves",
            "type": "string",
            "format": ""
        },
        {
            "name": "pgn",
            "baseName": "pgn",
            "type": "string",
            "format": ""
        },
        {
            "name": "daysPerTurn",
            "baseName": "daysPerTurn",
            "type": "number",
            "format": ""
        },
        {
            "name": "analysis",
            "baseName": "analysis",
            "type": "Array<GameJsonAnalysis>",
            "format": ""
        },
        {
            "name": "tournament",
            "baseName": "tournament",
            "type": "string",
            "format": ""
        },
        {
            "name": "swiss",
            "baseName": "swiss",
            "type": "string",
            "format": ""
        },
        {
            "name": "clock",
            "baseName": "clock",
            "type": "GameJsonClock",
            "format": ""
        }    ];

    static getAttributeTypeMap() {
        return GameJson.attributeTypeMap;
    }

    public constructor() {
    }
}


export type GameJsonWinnerEnum = "white" | "black" ;

