/**
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { GameStatus } from './GameStatus';
import { HttpFile } from '../http/http';

export class GameStateEvent {
    /**
    * Current moves in UCI format
    */
    'moves': string;
    /**
    * Integer of milliseconds White has left on the clock
    */
    'wtime': number;
    /**
    * Integer of milliseconds Black has left on the clock
    */
    'btime': number;
    /**
    * Integer of White Fisher increment.
    */
    'winc': number;
    /**
    * Integer of Black Fisher increment.
    */
    'binc': number;
    'status': GameStatus;
    /**
    * Color of the winner, if any
    */
    'winner'?: string;
    /**
    * true if white is offering draw, else omitted
    */
    'wdraw'?: boolean;
    /**
    * true if black is offering draw, else omitted
    */
    'bdraw'?: boolean;
    /**
    * true if white is proposing takeback, else omitted
    */
    'wtakeback'?: boolean;
    /**
    * true if black is proposing takeback, else omitted
    */
    'btakeback'?: boolean;

    static readonly discriminator: string | undefined = undefined;

    static readonly attributeTypeMap: Array<{name: string, baseName: string, type: string, format: string}> = [
        {
            "name": "moves",
            "baseName": "moves",
            "type": "string",
            "format": ""
        },
        {
            "name": "wtime",
            "baseName": "wtime",
            "type": "number",
            "format": ""
        },
        {
            "name": "btime",
            "baseName": "btime",
            "type": "number",
            "format": ""
        },
        {
            "name": "winc",
            "baseName": "winc",
            "type": "number",
            "format": ""
        },
        {
            "name": "binc",
            "baseName": "binc",
            "type": "number",
            "format": ""
        },
        {
            "name": "status",
            "baseName": "status",
            "type": "GameStatus",
            "format": ""
        },
        {
            "name": "winner",
            "baseName": "winner",
            "type": "string",
            "format": ""
        },
        {
            "name": "wdraw",
            "baseName": "wdraw",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "bdraw",
            "baseName": "bdraw",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "wtakeback",
            "baseName": "wtakeback",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "btakeback",
            "baseName": "btakeback",
            "type": "boolean",
            "format": ""
        }    ];

    static getAttributeTypeMap() {
        return GameStateEvent.attributeTypeMap;
    }

    public constructor() {
    }
}

