export * from './ApiStreamEvent';
export * from './ArenaTournaments';
export * from './ChallengeCanceledEvent';
export * from './ChallengeDeclinedEvent';
export * from './ChallengeEvent';
export * from './ChallengeJson';
export * from './ChallengeJsonPerf';
export * from './ChallengeUser';
export * from './ChatLineEvent';
export * from './Clock';
export * from './Count';
export * from './GameEventInfo';
export * from './GameEventInfoCompat';
export * from './GameEventPlayer';
export * from './GameFinishEvent';
export * from './GameFullEvent';
export * from './GameFullEventPerf';
export * from './GameJson';
export * from './GameJsonAnalysis';
export * from './GameJsonClock';
export * from './GameJsonJudgment';
export * from './GameJsonOpening';
export * from './GameJsonPlayers';
export * from './GameStartEvent';
export * from './GameStateEvent';
export * from './GameStatus';
export * from './GameStreamEvent';
export * from './GameUser';
export * from './GameUserAnalysis';
export * from './InlineResponse200';
export * from './InlineResponse2001';
export * from './InlineResponse2002';
export * from './InlineResponse2003';
export * from './LightUser';
export * from './ModelError';
export * from './Move';
export * from './NotFound';
export * from './Ok';
export * from './Perf';
export * from './PerfType';
export * from './Perfs';
export * from './PlayTime';
export * from './Profile';
export * from './PuzzleRoundJson';
export * from './Speed';
export * from './StormPerf';
export * from './SwissUnauthorisedEdit';
export * from './TablebaseJson';
export * from './Team';
export * from './TimeControl';
export * from './TimeControlClock';
export * from './TimeControlClockAllOf';
export * from './TimeControlCorrespondence';
export * from './TimeControlCorrespondenceAllOf';
export * from './TimeControlUnlimited';
export * from './Title';
export * from './User';
export * from './UserExtended';
export * from './UserExtendedAllOf';
export * from './UserPreferences';
export * from './Variant';
export * from './VariantKey';

import { ApiStreamEvent } from './ApiStreamEvent';
import { ArenaTournaments } from './ArenaTournaments';
import { ChallengeCanceledEvent } from './ChallengeCanceledEvent';
import { ChallengeDeclinedEvent } from './ChallengeDeclinedEvent';
import { ChallengeEvent } from './ChallengeEvent';
import { ChallengeJson  , ChallengeJsonStatusEnum        , ChallengeJsonColorEnum   , ChallengeJsonDirectionEnum     } from './ChallengeJson';
import { ChallengeJsonPerf } from './ChallengeJsonPerf';
import { ChallengeUser } from './ChallengeUser';
import { ChatLineEvent, ChatLineEventRoomEnum     } from './ChatLineEvent';
import { Clock } from './Clock';
import { Count } from './Count';
import { GameEventInfo , GameEventInfoSourceEnum    } from './GameEventInfo';
import { GameEventInfoCompat } from './GameEventInfoCompat';
import { GameEventPlayer } from './GameEventPlayer';
import { GameFinishEvent } from './GameFinishEvent';
import { GameFullEvent         , GameFullEventInitialFenEnum     } from './GameFullEvent';
import { GameFullEventPerf } from './GameFullEventPerf';
import { GameJson          , GameJsonWinnerEnum           } from './GameJson';
import { GameJsonAnalysis } from './GameJsonAnalysis';
import { GameJsonClock } from './GameJsonClock';
import { GameJsonJudgment, GameJsonJudgmentNameEnum    } from './GameJsonJudgment';
import { GameJsonOpening } from './GameJsonOpening';
import { GameJsonPlayers } from './GameJsonPlayers';
import { GameStartEvent } from './GameStartEvent';
import { GameStateEvent } from './GameStateEvent';
import { GameStatus } from './GameStatus';
import { GameStreamEvent } from './GameStreamEvent';
import { GameUser } from './GameUser';
import { GameUserAnalysis } from './GameUserAnalysis';
import { InlineResponse200 } from './InlineResponse200';
import { InlineResponse2001 } from './InlineResponse2001';
import { InlineResponse2002 } from './InlineResponse2002';
import { InlineResponse2003 } from './InlineResponse2003';
import { LightUser } from './LightUser';
import { ModelError } from './ModelError';
import { Move  , MoveCategoryEnum           } from './Move';
import { NotFound } from './NotFound';
import { Ok } from './Ok';
import { Perf } from './Perf';
import { PerfType } from './PerfType';
import { Perfs } from './Perfs';
import { PlayTime } from './PlayTime';
import { Profile } from './Profile';
import { PuzzleRoundJson } from './PuzzleRoundJson';
import { Speed } from './Speed';
import { StormPerf } from './StormPerf';
import { SwissUnauthorisedEdit } from './SwissUnauthorisedEdit';
import { TablebaseJson, TablebaseJsonCategoryEnum           } from './TablebaseJson';
import { Team } from './Team';
import { TimeControl } from './TimeControl';
import { TimeControlClock } from './TimeControlClock';
import { TimeControlClockAllOf } from './TimeControlClockAllOf';
import { TimeControlCorrespondence } from './TimeControlCorrespondence';
import { TimeControlCorrespondenceAllOf } from './TimeControlCorrespondenceAllOf';
import { TimeControlUnlimited } from './TimeControlUnlimited';
import { Title } from './Title';
import { User } from './User';
import { UserExtended } from './UserExtended';
import { UserExtendedAllOf } from './UserExtendedAllOf';
import { UserPreferences    , UserPreferencesThemeEnum  , UserPreferencesPieceSetEnum  , UserPreferencesTheme3dEnum  , UserPreferencesPieceSet3dEnum  , UserPreferencesSoundSetEnum                             } from './UserPreferences';
import { Variant } from './Variant';
import { VariantKey } from './VariantKey';

/* tslint:disable:no-unused-variable */
let primitives = [
                    "string",
                    "boolean",
                    "double",
                    "integer",
                    "long",
                    "float",
                    "number",
                    "any"
                 ];

const supportedMediaTypes: { [mediaType: string]: number } = {
  "application/json": Infinity,
  "application/octet-stream": 0,
  "application/x-www-form-urlencoded": 0
}


let enumsMap: Set<string> = new Set<string>([
    "ChallengeJsonStatusEnum",
    "ChallengeJsonColorEnum",
    "ChallengeJsonDirectionEnum",
    "ChatLineEventRoomEnum",
    "GameEventInfoSourceEnum",
    "GameFullEventInitialFenEnum",
    "GameJsonWinnerEnum",
    "GameJsonJudgmentNameEnum",
    "GameStatus",
    "MoveCategoryEnum",
    "PerfType",
    "Speed",
    "TablebaseJsonCategoryEnum",
    "Title",
    "UserPreferencesThemeEnum",
    "UserPreferencesPieceSetEnum",
    "UserPreferencesTheme3dEnum",
    "UserPreferencesPieceSet3dEnum",
    "UserPreferencesSoundSetEnum",
    "VariantKey",
]);

let typeMap: {[index: string]: any} = {
    "ApiStreamEvent": ApiStreamEvent,
    "ArenaTournaments": ArenaTournaments,
    "ChallengeCanceledEvent": ChallengeCanceledEvent,
    "ChallengeDeclinedEvent": ChallengeDeclinedEvent,
    "ChallengeEvent": ChallengeEvent,
    "ChallengeJson": ChallengeJson,
    "ChallengeJsonPerf": ChallengeJsonPerf,
    "ChallengeUser": ChallengeUser,
    "ChatLineEvent": ChatLineEvent,
    "Clock": Clock,
    "Count": Count,
    "GameEventInfo": GameEventInfo,
    "GameEventInfoCompat": GameEventInfoCompat,
    "GameEventPlayer": GameEventPlayer,
    "GameFinishEvent": GameFinishEvent,
    "GameFullEvent": GameFullEvent,
    "GameFullEventPerf": GameFullEventPerf,
    "GameJson": GameJson,
    "GameJsonAnalysis": GameJsonAnalysis,
    "GameJsonClock": GameJsonClock,
    "GameJsonJudgment": GameJsonJudgment,
    "GameJsonOpening": GameJsonOpening,
    "GameJsonPlayers": GameJsonPlayers,
    "GameStartEvent": GameStartEvent,
    "GameStateEvent": GameStateEvent,
    "GameStreamEvent": GameStreamEvent,
    "GameUser": GameUser,
    "GameUserAnalysis": GameUserAnalysis,
    "InlineResponse200": InlineResponse200,
    "InlineResponse2001": InlineResponse2001,
    "InlineResponse2002": InlineResponse2002,
    "InlineResponse2003": InlineResponse2003,
    "LightUser": LightUser,
    "ModelError": ModelError,
    "Move": Move,
    "NotFound": NotFound,
    "Ok": Ok,
    "Perf": Perf,
    "Perfs": Perfs,
    "PlayTime": PlayTime,
    "Profile": Profile,
    "PuzzleRoundJson": PuzzleRoundJson,
    "StormPerf": StormPerf,
    "SwissUnauthorisedEdit": SwissUnauthorisedEdit,
    "TablebaseJson": TablebaseJson,
    "Team": Team,
    "TimeControl": TimeControl,
    "TimeControlClock": TimeControlClock,
    "TimeControlClockAllOf": TimeControlClockAllOf,
    "TimeControlCorrespondence": TimeControlCorrespondence,
    "TimeControlCorrespondenceAllOf": TimeControlCorrespondenceAllOf,
    "TimeControlUnlimited": TimeControlUnlimited,
    "User": User,
    "UserExtended": UserExtended,
    "UserExtendedAllOf": UserExtendedAllOf,
    "UserPreferences": UserPreferences,
    "Variant": Variant,
}

export class ObjectSerializer {
    public static findCorrectType(data: any, expectedType: string) {
        if (data == undefined) {
            return expectedType;
        } else if (primitives.indexOf(expectedType.toLowerCase()) !== -1) {
            return expectedType;
        } else if (expectedType === "Date") {
            return expectedType;
        } else {
            if (enumsMap.has(expectedType)) {
                return expectedType;
            }

            if (!typeMap[expectedType]) {
                return expectedType; // w/e we don't know the type
            }

            // Check the discriminator
            let discriminatorProperty = typeMap[expectedType].discriminator;
            if (discriminatorProperty == null) {
                return expectedType; // the type does not have a discriminator. use it.
            } else {
                if (data[discriminatorProperty]) {
                    var discriminatorType = data[discriminatorProperty];
                    if(typeMap[discriminatorType]){
                        return discriminatorType; // use the type given in the discriminator
                    } else {
                        return expectedType; // discriminator did not map to a type
                    }
                } else {
                    return expectedType; // discriminator was not present (or an empty string)
                }
            }
        }
    }

    public static serialize(data: any, type: string, format: string) {
        if (data == undefined) {
            return data;
        } else if (primitives.indexOf(type.toLowerCase()) !== -1) {
            return data;
        } else if (type.lastIndexOf("Array<", 0) === 0) { // string.startsWith pre es6
            let subType: string = type.replace("Array<", ""); // Array<Type> => Type>
            subType = subType.substring(0, subType.length - 1); // Type> => Type
            let transformedData: any[] = [];
            for (let index in data) {
                let date = data[index];
                transformedData.push(ObjectSerializer.serialize(date, subType, format));
            }
            return transformedData;
        } else if (type === "Date") {
            if (format == "date") {
                let month = data.getMonth()+1
                month = month < 10 ? "0" + month.toString() : month.toString()
                let day = data.getDate();
                day = day < 10 ? "0" + day.toString() : day.toString();

                return data.getFullYear() + "-" + month + "-" + day;
            } else {
                return data.toISOString();
            }
        } else {
            if (enumsMap.has(type)) {
                return data;
            }
            if (!typeMap[type]) { // in case we dont know the type
                return data;
            }

            // Get the actual type of this object
            type = this.findCorrectType(data, type);

            // get the map for the correct type.
            let attributeTypes = typeMap[type].getAttributeTypeMap();
            let instance: {[index: string]: any} = {};
            for (let index in attributeTypes) {
                let attributeType = attributeTypes[index];
                instance[attributeType.baseName] = ObjectSerializer.serialize(data[attributeType.name], attributeType.type, attributeType.format);
            }
            return instance;
        }
    }

    public static deserialize(data: any, type: string, format: string) {
        // polymorphism may change the actual type.
        type = ObjectSerializer.findCorrectType(data, type);
        if (data == undefined) {
            return data;
        } else if (primitives.indexOf(type.toLowerCase()) !== -1) {
            return data;
        } else if (type.lastIndexOf("Array<", 0) === 0) { // string.startsWith pre es6
            let subType: string = type.replace("Array<", ""); // Array<Type> => Type>
            subType = subType.substring(0, subType.length - 1); // Type> => Type
            let transformedData: any[] = [];
            for (let index in data) {
                let date = data[index];
                transformedData.push(ObjectSerializer.deserialize(date, subType, format));
            }
            return transformedData;
        } else if (type === "Date") {
            return new Date(data);
        } else {
            if (enumsMap.has(type)) {// is Enum
                return data;
            }

            if (!typeMap[type]) { // dont know the type
                return data;
            }
            let instance = new typeMap[type]();
            let attributeTypes = typeMap[type].getAttributeTypeMap();
            for (let index in attributeTypes) {
                let attributeType = attributeTypes[index];
                instance[attributeType.name] = ObjectSerializer.deserialize(data[attributeType.baseName], attributeType.type, attributeType.format);
            }
            return instance;
        }
    }


    /**
     * Normalize media type
     *
     * We currently do not handle any media types attributes, i.e. anything
     * after a semicolon. All content is assumed to be UTF-8 compatible.
     */
    public static normalizeMediaType(mediaType: string | undefined): string | undefined {
        if (mediaType === undefined) {
            return undefined;
        }
        return mediaType.split(";")[0].trim().toLowerCase();
    }

    /**
     * From a list of possible media types, choose the one we can handle best.
     *
     * The order of the given media types does not have any impact on the choice
     * made.
     */
    public static getPreferredMediaType(mediaTypes: Array<string>): string {
        /** According to OAS 3 we should default to json */
        if (!mediaTypes) {
            return "application/json";
        }

        const normalMediaTypes = mediaTypes.map(this.normalizeMediaType);
        let selectedMediaType: string | undefined = undefined;
        let selectedRank: number = -Infinity;
        for (const mediaType of normalMediaTypes) {
            if (supportedMediaTypes[mediaType!] > selectedRank) {
                selectedMediaType = mediaType;
                selectedRank = supportedMediaTypes[mediaType!];
            }
        }

        if (selectedMediaType === undefined) {
            throw new Error("None of the given media types are supported: " + mediaTypes.join(", "));
        }

        return selectedMediaType!;
    }

    /**
     * Convert data to a string according the given media type
     */
    public static stringify(data: any, mediaType: string): string {
        if (mediaType === "application/json") {
            return JSON.stringify(data);
        }

        throw new Error("The mediaType " + mediaType + " is not supported by ObjectSerializer.stringify.");
    }

    /**
     * Parse data from a string according to the given media type
     */
    public static parse(rawData: string, mediaType: string | undefined) {
        if (mediaType === undefined) {
            throw new Error("Cannot parse content. No Content-Type defined.");
        }

        if (mediaType === "application/json") {
            return JSON.parse(rawData);
        }

        throw new Error("The mediaType " + mediaType + " is not supported by ObjectSerializer.parse.");
    }
}
