/**
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { Perf } from './Perf';
import { StormPerf } from './StormPerf';
import { HttpFile } from '../http/http';

export class Perfs {
    'chess960'?: Perf;
    'atomic'?: Perf;
    'racingKings'?: Perf;
    'ultraBullet'?: Perf;
    'blitz'?: Perf;
    'kingOfTheHill'?: Perf;
    'bullet'?: Perf;
    'correspondence'?: Perf;
    'horde'?: Perf;
    'puzzle'?: Perf;
    'classical'?: Perf;
    'rapid'?: Perf;
    'storm'?: StormPerf;

    static readonly discriminator: string | undefined = undefined;

    static readonly attributeTypeMap: Array<{name: string, baseName: string, type: string, format: string}> = [
        {
            "name": "chess960",
            "baseName": "chess960",
            "type": "Perf",
            "format": ""
        },
        {
            "name": "atomic",
            "baseName": "atomic",
            "type": "Perf",
            "format": ""
        },
        {
            "name": "racingKings",
            "baseName": "racingKings",
            "type": "Perf",
            "format": ""
        },
        {
            "name": "ultraBullet",
            "baseName": "ultraBullet",
            "type": "Perf",
            "format": ""
        },
        {
            "name": "blitz",
            "baseName": "blitz",
            "type": "Perf",
            "format": ""
        },
        {
            "name": "kingOfTheHill",
            "baseName": "kingOfTheHill",
            "type": "Perf",
            "format": ""
        },
        {
            "name": "bullet",
            "baseName": "bullet",
            "type": "Perf",
            "format": ""
        },
        {
            "name": "correspondence",
            "baseName": "correspondence",
            "type": "Perf",
            "format": ""
        },
        {
            "name": "horde",
            "baseName": "horde",
            "type": "Perf",
            "format": ""
        },
        {
            "name": "puzzle",
            "baseName": "puzzle",
            "type": "Perf",
            "format": ""
        },
        {
            "name": "classical",
            "baseName": "classical",
            "type": "Perf",
            "format": ""
        },
        {
            "name": "rapid",
            "baseName": "rapid",
            "type": "Perf",
            "format": ""
        },
        {
            "name": "storm",
            "baseName": "storm",
            "type": "StormPerf",
            "format": ""
        }    ];

    static getAttributeTypeMap() {
        return Perfs.attributeTypeMap;
    }

    public constructor() {
    }
}

