/**
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { Move } from './Move';
import { HttpFile } from '../http/http';

export class TablebaseJson {
    /**
    * `cursed-win` and `blessed-loss` means the 50-move rule prevents the decisive result.  `maybe-win` and `maybe-loss` means exact result is unknown due to [DTZ rounding](https://syzygy-tables.info/metrics#dtz), i.e., the win or loss could also be prevented by the 50-move rule if the user has deviated from the tablebase recommendation since the last pawn move or capture. 
    */
    'category'?: TablebaseJsonCategoryEnum;
    /**
    * [DTZ50'' with rounding](https://syzygy-tables.info/metrics#dtz) or null if unknown 
    */
    'dtz'?: number;
    /**
    * Distance to mate (only for positions with not more than 5 pieces)
    */
    'dtm'?: number;
    'checkmate'?: boolean;
    'stalemate'?: boolean;
    /**
    * Only in chess variants
    */
    'variantWin'?: boolean;
    /**
    * Only in chess variants
    */
    'variantLoss'?: boolean;
    'insufficientMaterial'?: boolean;
    /**
    * Information about legal moves, best first
    */
    'moves'?: Array<Move>;

    static readonly discriminator: string | undefined = undefined;

    static readonly attributeTypeMap: Array<{name: string, baseName: string, type: string, format: string}> = [
        {
            "name": "category",
            "baseName": "category",
            "type": "TablebaseJsonCategoryEnum",
            "format": ""
        },
        {
            "name": "dtz",
            "baseName": "dtz",
            "type": "number",
            "format": ""
        },
        {
            "name": "dtm",
            "baseName": "dtm",
            "type": "number",
            "format": ""
        },
        {
            "name": "checkmate",
            "baseName": "checkmate",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "stalemate",
            "baseName": "stalemate",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "variantWin",
            "baseName": "variant_win",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "variantLoss",
            "baseName": "variant_loss",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "insufficientMaterial",
            "baseName": "insufficient_material",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "moves",
            "baseName": "moves",
            "type": "Array<Move>",
            "format": ""
        }    ];

    static getAttributeTypeMap() {
        return TablebaseJson.attributeTypeMap;
    }

    public constructor() {
    }
}


export type TablebaseJsonCategoryEnum = "win" | "unknown" | "maybe-win" | "cursed-win" | "draw" | "blessed-loss" | "maybe-loss" | "loss" ;

