/**
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { Perfs } from './Perfs';
import { PlayTime } from './PlayTime';
import { Profile } from './Profile';
import { Title } from './Title';
import { HttpFile } from '../http/http';

export class User {
    'id'?: string;
    'username'?: string;
    'online'?: boolean;
    'perfs'?: Perfs;
    'createdAt'?: number;
    'disabled'?: boolean;
    'tosViolation'?: boolean;
    'profile'?: Profile;
    'seenAt'?: number;
    'patron'?: boolean;
    'verified'?: boolean;
    'playTime'?: PlayTime;
    'title'?: Title;

    static readonly discriminator: string | undefined = undefined;

    static readonly attributeTypeMap: Array<{name: string, baseName: string, type: string, format: string}> = [
        {
            "name": "id",
            "baseName": "id",
            "type": "string",
            "format": ""
        },
        {
            "name": "username",
            "baseName": "username",
            "type": "string",
            "format": ""
        },
        {
            "name": "online",
            "baseName": "online",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "perfs",
            "baseName": "perfs",
            "type": "Perfs",
            "format": ""
        },
        {
            "name": "createdAt",
            "baseName": "createdAt",
            "type": "number",
            "format": ""
        },
        {
            "name": "disabled",
            "baseName": "disabled",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "tosViolation",
            "baseName": "tosViolation",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "profile",
            "baseName": "profile",
            "type": "Profile",
            "format": ""
        },
        {
            "name": "seenAt",
            "baseName": "seenAt",
            "type": "number",
            "format": ""
        },
        {
            "name": "patron",
            "baseName": "patron",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "verified",
            "baseName": "verified",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "playTime",
            "baseName": "playTime",
            "type": "PlayTime",
            "format": ""
        },
        {
            "name": "title",
            "baseName": "title",
            "type": "Title",
            "format": ""
        }    ];

    static getAttributeTypeMap() {
        return User.attributeTypeMap;
    }

    public constructor() {
    }
}

