/**
 * Lichess.org API reference
 * # Introduction Welcome to the reference for the Lichess API! Lichess is free/libre, open-source chess server powered by volunteers and donations. - Get help in the [Lichess Discord channel](https://discord.gg/lichess) - [Contribute to this documentation on Github](https://github.com/lichess-org/api) - Check out [Lichess widgets to embed in your website](https://lichess.org/developers) - [Download all Lichess rated games](https://database.lichess.org/) - [Download all Lichess puzzles with themes, ratings and votes](https://database.lichess.org/#puzzles)  ## Endpoint All requests go to `https://lichess.org` (unless otherwise specified).  ## Clients - [Python general API](https://github.com/ZackClements/berserk) - [MicroPython general API](https://github.com/mkomon/uberserk) - [Python general API - async](https://pypi.org/project/async-lichess-sdk) - [Python Lichess Bot](https://github.com/careless25/lichess-bot) - [Python Board API for Certabo](https://github.com/haklein/certabo-lichess) - [Java general API](https://github.com/tors42/chariot)  ## Rate limiting All requests are rate limited using various strategies, to ensure the API remains responsive for everyone. Only make one request at a time. If you receive an HTTP response with a [429 status](https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#429), please wait a full minute before resuming API usage.  ## Streaming with ND-JSON Some API endpoints stream their responses as [Newline Delimited JSON a.k.a. **nd-json**](http://ndjson.org/), with one JSON object per line.  Here's a [JavaScript utility function](https://gist.github.com/ornicar/a097406810939cf7be1df8ea30e94f3e) to help reading NDJSON streamed responses. 
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { URI } from './URI';
import { HttpFile } from '../http/http';

export class UserPreferences {
    'dark'?: boolean;
    'transp'?: boolean;
    'bgImg'?: URI;
    'is3d'?: boolean;
    'theme'?: UserPreferencesThemeEnum;
    'pieceSet'?: UserPreferencesPieceSetEnum;
    'theme3d'?: UserPreferencesTheme3dEnum;
    'pieceSet3d'?: UserPreferencesPieceSet3dEnum;
    'soundSet'?: UserPreferencesSoundSetEnum;
    'blindfold'?: number;
    'autoQueen'?: number;
    'autoThreefold'?: number;
    'takeback'?: number;
    'moretime'?: number;
    'clockTenths'?: number;
    'clockBar'?: boolean;
    'clockSound'?: boolean;
    'premove'?: boolean;
    'animation'?: number;
    'captured'?: boolean;
    'follow'?: boolean;
    'highlight'?: boolean;
    'destination'?: boolean;
    'coords'?: number;
    'replay'?: number;
    'challenge'?: number;
    'message'?: number;
    'coordColor'?: number;
    'submitMove'?: number;
    'confirmResign'?: number;
    'insightShare'?: number;
    'keyboardMove'?: number;
    'zen'?: number;
    'moveEvent'?: number;
    'rookCastle'?: number;

    static readonly discriminator: string | undefined = undefined;

    static readonly attributeTypeMap: Array<{name: string, baseName: string, type: string, format: string}> = [
        {
            "name": "dark",
            "baseName": "dark",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "transp",
            "baseName": "transp",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "bgImg",
            "baseName": "bgImg",
            "type": "URI",
            "format": "uri"
        },
        {
            "name": "is3d",
            "baseName": "is3d",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "theme",
            "baseName": "theme",
            "type": "UserPreferencesThemeEnum",
            "format": ""
        },
        {
            "name": "pieceSet",
            "baseName": "pieceSet",
            "type": "UserPreferencesPieceSetEnum",
            "format": ""
        },
        {
            "name": "theme3d",
            "baseName": "theme3d",
            "type": "UserPreferencesTheme3dEnum",
            "format": ""
        },
        {
            "name": "pieceSet3d",
            "baseName": "pieceSet3d",
            "type": "UserPreferencesPieceSet3dEnum",
            "format": ""
        },
        {
            "name": "soundSet",
            "baseName": "soundSet",
            "type": "UserPreferencesSoundSetEnum",
            "format": ""
        },
        {
            "name": "blindfold",
            "baseName": "blindfold",
            "type": "number",
            "format": ""
        },
        {
            "name": "autoQueen",
            "baseName": "autoQueen",
            "type": "number",
            "format": ""
        },
        {
            "name": "autoThreefold",
            "baseName": "autoThreefold",
            "type": "number",
            "format": ""
        },
        {
            "name": "takeback",
            "baseName": "takeback",
            "type": "number",
            "format": ""
        },
        {
            "name": "moretime",
            "baseName": "moretime",
            "type": "number",
            "format": ""
        },
        {
            "name": "clockTenths",
            "baseName": "clockTenths",
            "type": "number",
            "format": ""
        },
        {
            "name": "clockBar",
            "baseName": "clockBar",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "clockSound",
            "baseName": "clockSound",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "premove",
            "baseName": "premove",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "animation",
            "baseName": "animation",
            "type": "number",
            "format": ""
        },
        {
            "name": "captured",
            "baseName": "captured",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "follow",
            "baseName": "follow",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "highlight",
            "baseName": "highlight",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "destination",
            "baseName": "destination",
            "type": "boolean",
            "format": ""
        },
        {
            "name": "coords",
            "baseName": "coords",
            "type": "number",
            "format": ""
        },
        {
            "name": "replay",
            "baseName": "replay",
            "type": "number",
            "format": ""
        },
        {
            "name": "challenge",
            "baseName": "challenge",
            "type": "number",
            "format": ""
        },
        {
            "name": "message",
            "baseName": "message",
            "type": "number",
            "format": ""
        },
        {
            "name": "coordColor",
            "baseName": "coordColor",
            "type": "number",
            "format": ""
        },
        {
            "name": "submitMove",
            "baseName": "submitMove",
            "type": "number",
            "format": ""
        },
        {
            "name": "confirmResign",
            "baseName": "confirmResign",
            "type": "number",
            "format": ""
        },
        {
            "name": "insightShare",
            "baseName": "insightShare",
            "type": "number",
            "format": ""
        },
        {
            "name": "keyboardMove",
            "baseName": "keyboardMove",
            "type": "number",
            "format": ""
        },
        {
            "name": "zen",
            "baseName": "zen",
            "type": "number",
            "format": ""
        },
        {
            "name": "moveEvent",
            "baseName": "moveEvent",
            "type": "number",
            "format": ""
        },
        {
            "name": "rookCastle",
            "baseName": "rookCastle",
            "type": "number",
            "format": ""
        }    ];

    static getAttributeTypeMap() {
        return UserPreferences.attributeTypeMap;
    }

    public constructor() {
    }
}


export type UserPreferencesThemeEnum = "blue" | "blue2" | "blue3" | "blue-marble" | "canvas" | "wood" | "wood2" | "wood3" | "wood4" | "maple" | "maple2" | "brown" | "leather" | "green" | "marble" | "green-plastic" | "grey" | "metal" | "olive" | "newspaper" | "purple" | "purple-diag" | "pink" | "ic" ;
export type UserPreferencesPieceSetEnum = "cburnett" | "merida" | "alpha" | "pirouetti" | "chessnut" | "chess7" | "reillycraig" | "companion" | "riohacha" | "kosal" | "leipzig" | "fantasy" | "spatial" | "california" | "pixel" | "maestro" | "fresca" | "cardinal" | "gioco" | "tatiana" | "staunty" | "governor" | "dubrovny" | "icpieces" | "shapes" | "letter" ;
export type UserPreferencesTheme3dEnum = "Black-White-Aluminium" | "Brushed-Aluminium" | "China-Blue" | "China-Green" | "China-Grey" | "China-Scarlet" | "Classic-Blue" | "Gold-Silver" | "Light-Wood" | "Power-Coated" | "Rosewood" | "Marble" | "Wax" | "Jade" | "Woodi" ;
export type UserPreferencesPieceSet3dEnum = "Basic" | "Wood" | "Metal" | "RedVBlue" | "ModernJade" | "ModernWood" | "Glass" | "Trimmed" | "Experimental" | "Staunton" | "CubesAndPi" ;
export type UserPreferencesSoundSetEnum = "silent" | "standard" | "piano" | "nes" | "sfx" | "futuristic" | "robot" | "music" | "speech" ;

